' FFSubmenu=Tools
' FFName=Metadatentransfer

'FFSkriptName=Metadatentransfer.vbs
'FFSkriptArchiv=Metadatentransfer.zip
'FFSkriptDirectory=\MeckiScript\Metadatentransfer
'FFSkriptFiles=
'FFScriptProfile=FF_Metadatentransfer

'FFSkriptAuthor=Harald Maeckler
'FFSkriptVersion=1.01
'FFVersion=2.91.0
'FFSkriptURL=http://www.meckis-steckenpferde.de/FixFoto_Skripte.html

' ********************************************************************
' Metadatentransfer (Skript fr FixFoto)
' Funktion:	Auswhlbare Metadaten in Bilder mit gleichem Stammnamen bertragen
'
' Copyright Harald Maeckler, Dsseldorf 2011
' ********************************************************************
' Version 1.02 vom 28.08.2011	- farbliche Kennzeichnung der Anzahl-Anzeige
'								- Quelle und Ziel drfen identisch sein
'								- Option unbercksichtigter Namenszusatz
' Version 1.01 vom 26.08.2011	- Anzeige der Anzahl ausgewhlter Daten
'								- Erzeugung eines Exif-Blocks wenn nicht vorhanden
' Version 1.00 vom 24.08.2011	- Betaversion
' ********************************************************************

'**Start Encode**

Option Explicit
Dim SkriptName
const Skript = "Metadatentransfer"					'Skriptname
const RegSchluessel = "FF_Metadatentransfer"		'Registryschlssel

Dim objFS,WshShell										'Objekte
Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

Dim SkriptKill,Antwort,TempFile	 : SkriptKill = false	'Lschroutine
const ForReading = 1, ForWriting = 2
Dim SkriptAbbruch : SkriptAbbruch = false
Dim Abbruch : Abbruch = false

Dim B_Ordner,flag_IPTC,flag_Exif,Nzusatz_oB,flag_Nzusatz_oB
Dim bild_A,bild_B,bild_B_Liste,GesamtZ,Bild_Anzahl
Dim Exif_Liste,IPTC_Liste,Exif_Tags,IPTC_Tags,Exif_TagArray,IPTC_TagArray,flag_KeyWord,Z_KeyWord
Dim Exif_Werte(),IPTC_Werte(),Max_Exif,Max_IPTC,Anz_Exif,Anz_IPTC
Dim ArrayA,elementA,ArrayB,elementB
'-------------------------------------------------------------------------
'Hilfstext fr die Metadatenauswahl
Dim msg
msg = 	">   bertragt das ausgewhlte Element aus der Verfgungliste in die" & vbNewline & _
		"      Transferliste. Gleiches geschieht bei Maus-Doppelklick auf ein" & vbNewline & _
		"      Element in der Verfgungsliste." & vbNewline & _
		">> bertrgt alle Elemente der Verfgungsliste in die Transferliste." & vbNewline & _
		"<< lscht alle Elemente in der Transferliste." & vbNewline & _
		"<   lscht das ausgewhlte Element in der Transferliste. Gleiches" & vbNewline & _
		"      geschieht bei Maus-Doppelklick auf ein Element in der Transferliste."
'-------------------------------------------------------------------------
call main
Set objFS = nothing
Set WshShell = nothing
'-------------------------------------------------------------------------
Sub main
Dim Zielordner,Anzeige

on error resume next							'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	FF_GetScriptPath
 	if err > 0 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

if objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbs") then
	SkriptName = Skript & ".vbs"
elseif objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbe") then
	SkriptName = Skript & ".vbe"
else
	msgbox "Das Skript wurde umbenannt!",vbCritical,"Abbruch"
	exit sub
end if

'** Start Dialog Metadatentransfer **
FF_AddDialog "Metadatentransfer",212,156
FF_AddControl "Metadatentransfer","Metadaten aus Bildern im aktuellen Ordner","STATIC",6,5,200,10
FF_AddControl "Metadatentransfer","Ordner_Aktuell","SLEDIT",5,15,200,10
FF_SetControlStyle "Metadatentransfer","Ordner_Aktuell",2048
FF_AddControl "Metadatentransfer","werden gem Auswahl bertragen in Bilder mit gleichem Stammnamen im","STATIC",6,26,200,10
FF_AddControl "Metadatentransfer","Ordner","GROUP",5,38,200,25
FF_AddControl "Metadatentransfer","B_Ordner","SLEDIT",11,48,176,10
FF_SetControlStyle "Metadatentransfer","B_Ordner",2048
FF_AddControl "Metadatentransfer","...","BUTTON",191,48,10,10
FF_AddControl "Metadatentransfer","Metadatenauswahl","GROUP",5,68,148,51
FF_AddControl "Metadatentransfer","Exif","GROUP",9,78,68,35
FF_AddControl "Metadatentransfer","flag_Exif","BOOL",15,87,8,8
FF_SetControlStyle "Metadatentransfer","flag_Exif",16384
FF_AddControl "Metadatentransfer","Auswahl","BUTTON",31,86,33,10
FF_AddControl "Metadatentransfer","Anz_ExifD","SLEDIT",18,99,10,10
FF_SetControlStyle "Metadatentransfer","Anz_ExifD",2049
FF_AddControl "Metadatentransfer","Daten ausgewhlt","STATIC",30,99,45,10
FF_AddControl "Metadatentransfer","Exif_Kennung","IMAGE",14,99,4,10
FF_AddControl "Metadatentransfer","IPTC","GROUP",81,78,68,35
FF_AddControl "Metadatentransfer","flag_IPTC","BOOL",87,87,8,8
FF_SetControlStyle "Metadatentransfer","flag_IPTC",16384
FF_AddControl "Metadatentransfer","Auswahl|","BUTTON",103,86,33,10
FF_AddControl "Metadatentransfer","Anz_IptcD","SLEDIT",91,99,10,10
FF_SetControlStyle "Metadatentransfer","Anz_IptcD",2049
FF_AddControl "Metadatentransfer","Daten ausgewhlt|","STATIC",103,99,45,10
FF_AddControl "Metadatentransfer","IPTC_Kennung","IMAGE",87,99,4,10
FF_AddControl "Metadatentransfer","unbercksichtigter","GROUP",157,68,50,51
FF_AddControl "Metadatentransfer","Namenszusatz","STATIC",162,75,36,10
FF_AddControl "Metadatentransfer","flag_Nzusatz_oB","BOOL",162,87,8,8
FF_AddControl "Metadatentransfer","Nzusatz_oB","SLEDIT",172,86,32,10
FF_SetControlStyle "Metadatentransfer","Nzusatz_oB",1
FF_AddControl "Metadatentransfer","?|","BUTTON",177,99,11,11
FF_AddControl "Metadatentransfer","Fortschritt","PROGRESS",4,122,202,6
FF_AddControl "Metadatentransfer","Fortschritt_U","PROGRESS",4,130,202,4
FF_AddControl "Metadatentransfer","?","BUTTON",11,142,11,11
FF_AddControl "Metadatentransfer","Vorgang abrechen mit Taste <Backspace>","STATIC",43,143,104,10
FF_SetControlStyle "Metadatentransfer","Vorgang abrechen mit Taste <Backspace>",1
FF_AddControl "Metadatentransfer","Start","BUTTON",163,142,33,11
FF_AddControl "Metadatentransfer","&delete","BUTTON",5,8,1,1
'** End Dialog Metadatentransfer **

FF_SetControl "Metadatentransfer","Ordner_Aktuell",FF_GetImagePath

call RegistryLesen
call ExifTags_Ermittlung
call IPTCTags_Ermittlung


FF_ActivateControl "Metadatentransfer","&delete"

do
	Abbruch = false
	
	Select Case FF_ShowDialog ("Metadatentransfer")
	Case "&delete"
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "..."
		FF_SetCurrentPath B_Ordner
		Zielordner = FF_EnterPath(false,"Wahl des Ablageordners")
		if len(B_Ordner) > 2 then FF_SetControl "Metadatentransfer","B_Ordner",Zielordner
	Case "flag_Exif"
		flag_Exif = FF_GetControl("Metadatentransfer","flag_Exif")
		if flag_Exif = 1 then
			if Anz_Exif = 0 then
				FF_SetControl "Metadatentransfer","Exif_Kennung",FF_GetScriptPath & "\MeckiScript\Metadatentransfer\rot.png"
			else
				FF_SetControl "Metadatentransfer","Exif_Kennung",FF_GetScriptPath & "\MeckiScript\Metadatentransfer\gruen.png"
			end if
		else
			FF_SetControl "Metadatentransfer","Exif_Kennung",""
		end if
	Case "Auswahl"
		call Exif_Auswahl
		call ExifTags_Ermittlung
	Case "flag_IPTC"
		flag_IPTC = FF_GetControl("Metadatentransfer","flag_IPTC")
		if flag_IPTC = 1 then
			if Anz_IPTC = 0 then
				FF_SetControl "Metadatentransfer","IPTC_Kennung",FF_GetScriptPath & "\MeckiScript\Metadatentransfer\rot.png"
			else
				FF_SetControl "Metadatentransfer","IPTC_Kennung",FF_GetScriptPath & "\MeckiScript\Metadatentransfer\gruen.png"
			end if
		else
			FF_SetControl "Metadatentransfer","IPTC_Kennung",""
		end if
	Case "Auswahl|"
		call IPTC_Auswahl
		call IPTCTags_Ermittlung
	Case "?|"
		msgbox 	"Ist die Option 'unbercksichtigter Namenszusatz' aktiviert, wird bei" & vbNewLine & _
				"der Suche im Zielordner nach Bildern mit gleichem Stammnamen" & vbNewLine & _
				"der eingetragene Text nicht bercksichtigt." & vbNewline & vbNewline & _
				"Leerzeichen am Anfang oder Ende des Zusatzes sind nicht zugelassen!" & vbNewline & _
				"Sie werden ggf. automatisch entfernt.",vbInformation,"Erluterung"
	Case "?"
		'FF_SetControl "Metadatentransfer","Fortschritt",65		'############## nur fr Screenshot
		'FF_SetControl "Metadatentransfer","Fortschritt_U",30	'############## nur fr Screenshot

		Anzeige = """" & FF_GetScriptPath & "\MeckiScript\Metadatentransfer\Metadatentransfer.pdf" & """"
		on error resume next
		WshShell.Run Anzeige,1,false
		if err <> 0 then
			msgbox "Die Kurzbeschreibung konnte nicht geffnet werden." & vbNewLine & _
				   "Mglicherweise wurde die PDF-Datei gelscht oder" & vbNewLine & _
				   "es ist kein PDF-Reader installiert (?).",vbExclamation,"Hinweis"
			err.clear
		end if
		on error GoTo 0
	Case "Start"
		call Werte_Lesen
		call Kontrolle
		if not Abbruch then	call Bildsuche
		if not Abbruch then exit do
	Case "CANCEL"
		exit do
	Case Else
	End Select
loop

call RegistrySchreiben
FF_CloseDialog ("Metadatentransfer")

if SkriptKill then	'ggf. Skript 'Ordner lschen' komplett entfernen
	call KillSkript
end if

End Sub
'-------------------------------------------------------------------------
Sub ExifTags_Ermittlung

Anz_Exif = 0
if len(Exif_Liste) > 0 then
	Exif_Tags = ""
	if len(Exif_Liste) > 0 then	'> Exif_Tags
		ArrayA = split(Exif_Liste,";")
		for each elementA in ArrayA
			ArrayB = split(elementA,"|")
			if len(Exif_Tags) = 0 then
				Exif_Tags = trim(ArrayB(1))
			else
				Exif_Tags = Exif_Tags & ";" & trim(ArrayB(1))
			end if
		next
	end if
	
	Exif_TagArray = split(Exif_Tags,";")
	Max_Exif = ubound(Exif_TagArray)
	Anz_Exif = Max_Exif +1
	Redim Exif_Werte(Max_Exif)

end if

if flag_Exif = 1 then
	if Anz_Exif = 0 then
		FF_SetControl "Metadatentransfer","Exif_Kennung",FF_GetScriptPath & "\MeckiScript\Metadatentransfer\rot.png"
	else
		FF_SetControl "Metadatentransfer","Exif_Kennung",FF_GetScriptPath & "\MeckiScript\Metadatentransfer\gruen.png"
	end if
end if
FF_SetControl "Metadatentransfer","Anz_ExifD",Anz_Exif

End Sub
'-------------------------------------------------------------------------
Sub IPTCTags_Ermittlung

Anz_IPTC = 0
if len(IPTC_Liste) > 0 then
	IPTC_Tags = ""
	if len(IPTC_Liste) > 0 then	'> IPTC_Tags
		ArrayA = split(IPTC_Liste,";")
		for each elementA in ArrayA
			ArrayB = split(elementA,"|")
			if len(IPTC_Tags) = 0 then
				IPTC_Tags = trim(ArrayB(1))
			else
				IPTC_Tags = IPTC_Tags & ";" & trim(ArrayB(1))
			end if
		next
	end if

	IPTC_TagArray = split(IPTC_Tags,";")
	Max_IPTC = ubound(IPTC_TagArray)
	Anz_IPTC = Max_IPTC +1
	Redim IPTC_Werte(Max_IPTC)
end if

if flag_IPTC = 1 then
	if Anz_IPTC = 0 then
		FF_SetControl "Metadatentransfer","IPTC_Kennung",FF_GetScriptPath & "\MeckiScript\Metadatentransfer\rot.png"
	else
		FF_SetControl "Metadatentransfer","IPTC_Kennung",FF_GetScriptPath & "\MeckiScript\Metadatentransfer\gruen.png"
	end if
end if
FF_SetControl "Metadatentransfer","Anz_IptcD",Anz_IPTC
		
End Sub
'-------------------------------------------------------------------------
Sub Bildsuche
Dim Array,element,ext,n,pos,Quellname
Dim Ordner,Unterordner,f,f1,fc,U_Liste,Array_U,Bild_B

Ordner = B_Ordner
pos = InStrRev(B_Ordner,"\")
Unterordner = mid(Ordner,pos +1)

if FF_GetImagePath() = Ordner then
	Antwort = msgbox("Das gewhlte Computerverzeichnis und der zu" & vbNewLine & _
					 "durchsuchende Ordner sind identisch!"& vbNewLine & vbNewLine & _
					 "Ist das gewollt?",vbQuestion + vbYesNo,"Gleiche Ordner")
	if Antwort = vbNo then	Abbruch = true : exit sub
end if

Bild_Anzahl = 0 : n = 0

'### alle Bilder im Ordner
Set f = objFS.GetFolder(Ordner)
Set fc = f.files

for each f1 in fc
	ext = ucase(objFS.GetExtensionName(f1.name))
	if ext = "JPG" or ext = "TIF" then
		if len(U_Liste) = 0 then
			U_Liste = Ordner & "\" & f1.name
		else
			U_Liste = U_Liste & vbNewline & Ordner & "\" & f1.name
		end if
	end if
next

if len(U_Liste) = 0 then
	msgbox "Der Ordner '" & Unterordner & "' enthlt keine geeigneten Bilder!",vbInformation,"Abbruch"
	exit sub
end if

Array_U = split(U_Liste,vbNewline)

'### alle Bilder der Computeransicht
Array = split(FF_GetSelection(0),vbNewline)
GesamtZ = ubound(Array) +1

for each element in Array
	
	'### Abbruch?
	if FF_CheckKey() = 8 then SkriptAbbruch = true	'8 = Backspace
	if SkriptAbbruch then
		Antwort = msgbox("Von " & GesamtZ & " Bildern wurden bisher " & n & _
						 " Bilder bearbeitet." & vbNewLine & vbNewLine & _
						 "Soll der Metadatentransfer abgebrochen werden?",vbYesNo or vbQuestion,"Abfrage")
		SkriptAbbruch = false
		if Antwort = vbYes then exit sub
		
	end if
	
	'### Fortschritt
	n = n +1
	FF_SetControl "Metadatentransfer","Fortschritt",n/GesamtZ*100
	FF_SetControl "Metadatentransfer","Fortschritt_U",0

	'### bertragung
	ext  = ucase(objFS.GetExtensionName(element))
	if ext = "JPG" or ext = "TIF" then
		bild_A = element

		'Durchsuchen des Ordners
		Quellname = objFS.GetBaseName(element)
		if flag_Nzusatz_oB = 1 then
			Quellname = Replace(Quellname,Nzusatz_oB ,"",1,-1,vbTextCompare)
		end if

		for each bild_B in Array_U
			if instr(bild_B,Quellname) > 0 and ucase(bild_A) <> ucase(bild_B) then
				if len(bild_B_Liste) = 0 then
					bild_B_Liste = bild_B
				else
					bild_B_Liste = bild_B_Liste & vbNewline & bild_B
				end if
			end if
		Next
		
'Msgbox bild_A & vbNewline & vbNewLine & bild_B_Liste

		if FF_CheckKey() = 8 then SkriptAbbruch = true	'8 = Backspace
		if len(bild_B_Liste) > 0 then call Uebertragung					'Metadaten bertragen
		bild_B_Liste = ""

	end if
next

'### Abschluss
if Bild_Anzahl = 0 then
	msgbox "Es wurde im Ordner '" & Unterordner & "'" & vbNewLine & _
			"kein JPG- bzw. TIF-Bild mit gleichem Stammnamen gefunden!",vbInformation,"Schlussmeldung"
elseif Bild_Anzahl = 1 then
	msgbox "Es wurde in ein Bild Metadaten bertragen!",vbInformation,"Schlussmeldung"
else
	msgbox "Es wurden in " & Bild_Anzahl & " Bilder Metadaten bertragen!",vbInformation,"Schlussmeldung"
end if

End Sub
'------------------------------------------------------------------------
Sub Uebertragung
Dim Schlagworte,Array,element,m,Gesamt_A,n
Dim IPTC_vorhanden,Exif_vorhanden
IPTC_vorhanden = false : Exif_vorhanden = false

FF_LoadImage bild_A 'Quellbild

'### Metadaten ermitteln
'IPTC-Daten ermitteln
if FF_CheckKey() = 8 then SkriptAbbruch = true	'8 = Backspace
if flag_IPTC = 1 and FF_HasIPTC then
	IPTC_vorhanden = true
	for n = 0 to Max_IPTC
		IPTC_Werte(n) = FF_GetIPTC(IPTC_TagArray(n))
		if IPTC_TagArray(n) = "Keywords" and flag_KeyWord = 1 then
			IPTC_Werte(n) = IPTC_Werte(n) & vbNewline & Z_KeyWord
		end if
	next
end if

'Exif-Daten ermitteln
if FF_CheckKey() = 8 then SkriptAbbruch = true	'8 = Backspace
if flag_Exif = 1 and FF_HasExif then
	Exif_vorhanden = true
	for n = 0 to Max_Exif
		Exif_Werte(n) = FF_GetExifTag(Exif_TagArray(n))
	next
end if

'###Metadaten in das (die) Zielbild(er) eintragen
Array = split(bild_B_Liste,vbNewline)
Gesamt_A = ubound(Array) +1
for each element in Array
	Bild_Anzahl = Bild_Anzahl +1
	m = m +1
	FF_SetControl "Metadatentransfer","Fortschritt_U",m/Gesamt_A*100
	FF_LoadImage element			'Zielbild
	
	if FF_CheckKey() = 8 then SkriptAbbruch = true	'8 = Backspace
	
	'IPTC-Daten eintragen
	if IPTC_vorhanden and FF_HasIPTC then
		for n = 0 to Max_IPTC
			FF_SetIPTC IPTC_TagArray(n),IPTC_Werte(n)
		next
		FF_SaveIPTC element
	end if
	
	if FF_CheckKey() = 8 then SkriptAbbruch = true	'8 = Backspace
	
	'Exif-Daten eintragen
	if Exif_vorhanden then
		if not FF_HasExif then
			if ucase(objFS.GetExtensionName(element)) = "JPG" then FF_CreateExif()
		end if
		if FF_HasExif then
			for n = 0 to Max_Exif
				FF_SetExifTag Exif_TagArray(n),Exif_Werte(n)
			next
			FF_SaveExif element
		end if
	end if
next

End Sub
'------------------------------------------------------------------------
Sub Werte_Lesen

B_Ordner = FF_GetControl("Metadatentransfer","B_Ordner")
flag_IPTC = FF_GetControl("Metadatentransfer","flag_IPTC")
flag_Exif= FF_GetControl("Metadatentransfer","flag_Exif")

flag_Nzusatz_oB = FF_GetControl("Metadatentransfer","flag_Nzusatz_oB")
Nzusatz_oB = trim(FF_GetControl("Metadatentransfer","Nzusatz_oB"))

End Sub
'-------------------------------------------------------------------------
Sub Kontrolle

if flag_Exif = 0 and flag_IPTC = 0 then
	msgbox "Es wurde keine Metadatendatenauswahl getroffen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

if flag_Exif = 1 and len(Exif_Liste) = 0 then
	msgbox 	"Die Metadatenauswahl 'Exif' ist aktiviert," & vbNewline & _
			"aber es sind keine Exif-Daten ausgewhlt!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

if flag_IPTC = 1 and len(IPTC_Liste) = 0 then
	msgbox 	"Die Metadatenauswahl 'IPTC' ist aktiviert," & vbNewline & _
			"aber es sind keine IPTC-Daten ausgewhlt!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

if flag_Nzusatz_oB = 1 and len(Nzusatz_oB) = 0 then
	msgbox 	"Die Option 'unbercksichtigter Datenzusatz' ist aktiviert," & vbNewline & _
			"aber es ist kein Datenzusatz definiert!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

End Sub
'-------------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

'### Werte auslesen
B_Ordner =  FF_GetProfile (RegSchluessel,"B_Ordner")
if not objFS.FolderExists(B_Ordner) then B_Ordner = "C:\"

flag_IPTC =  FF_GetProfile (RegSchluessel,"flag_IPTC")
if flag_IPTC = "" then flag_IPTC = 0

flag_Exif =  FF_GetProfile (RegSchluessel,"flag_Exif")
if flag_Exif = "" then flag_Exif = 0

Exif_Liste =  FF_GetProfile (RegSchluessel,"Exif_Liste")
IPTC_Liste =  FF_GetProfile (RegSchluessel,"IPTC_Liste")

flag_KeyWord =  FF_GetProfile (RegSchluessel,"flag_KeyWord")
if flag_KeyWord = "" then flag_KeyWord = 0
Z_KeyWord =  FF_GetProfile (RegSchluessel,"Z_KeyWord")

flag_Nzusatz_oB =  FF_GetProfile (RegSchluessel,"flag_Nzusatz_oB")
if flag_Nzusatz_oB = "" then flag_Nzusatz_oB = 0

Nzusatz_oB =  FF_GetProfile (RegSchluessel,"Nzusatz_oB")

'### Werte eintragen
FF_SetControl "Metadatentransfer","B_Ordner",B_Ordner
FF_SetControl "Metadatentransfer","flag_IPTC",flag_IPTC
FF_SetControl "Metadatentransfer","flag_Exif",flag_Exif
FF_SetControl "Metadatentransfer","flag_Nzusatz_oB",flag_Nzusatz_oB
FF_SetControl "Metadatentransfer","Nzusatz_oB",Nzusatz_oB


End Sub
'-------------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

call Werte_Lesen

'Werte schreiben
FF_WriteProfile RegSchluessel,"B_Ordner",B_Ordner
FF_WriteProfile RegSchluessel,"flag_IPTC",flag_IPTC
FF_WriteProfile RegSchluessel,"flag_Exif",flag_Exif
FF_WriteProfile RegSchluessel,"flag_Nzusatz_oB",flag_Nzusatz_oB
FF_WriteProfile RegSchluessel,"Nzusatz_oB",Nzusatz_oB

End Sub
'-------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Dateien und Ordner lschen
'TempFile = FF_GetScriptPath & "\Beipack.txt"		'Dateibeispiel
'if objFS.FileExists(TempFile) then objFS.DeleteFile TempFile,true

TempFile = FF_GetScriptPath & "\MeckiScript\Metadatentransfer"
if objFS.FolderExists(TempFile) then objFS.DeleteFolder TempFile

'### ggf. Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\" & RegSchluessel & "\"
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Das Skript" & Skriptname & vbNewLine & "wurde mit allen Komponenten gelscht!" & vbNewLine & _
	   "Es wird empfohlen die 'Automatische Skriptkonfiguration' aufzurufen.",vbExclamation,"Hinweis"

End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------
Sub Exif_Auswahl
'Exif_Lpassiv Exif_Laktiv
const ExifDatenliste = "Fotograf | Artist;Rechte Fotograf | Copyright1;Rechte Herausgeber | Copyright2;Bildbeschreibung | ImageDescription;Kommentar | UserComment;Software | Software;Breitengrad | Latitude;Lngengrad | Longitude;Hhe | Altitude;Anz. Satelliten | Satellites"

Dim Array_P,Array_A,element,Wert,pos1,pos2

'** Start Dialog Exif-Auswahl **
FF_AddDialog "Exif-Auswahl",283,102
FF_AddControl "Exif-Auswahl","Verfgungsliste","STATIC",5,5,50,10
FF_AddControl "Exif-Auswahl","Exif_Lpassiv","LISTBOX",5,15,126,66
FF_AddControl "Exif-Auswahl",">","BUTTON",135,18,12,11
FF_AddControl "Exif-Auswahl",">>","BUTTON",135,31,12,11
FF_AddControl "Exif-Auswahl","<<","BUTTON",135,47,12,11
FF_AddControl "Exif-Auswahl","<","BUTTON",135,62,12,11
FF_AddControl "Exif-Auswahl","Transferliste","STATIC",151,5,50,10
FF_AddControl "Exif-Auswahl","Exif_Laktiv","LISTBOX",151,15,126,66
FF_AddControl "Exif-Auswahl","?","BUTTON",9,85,11,11
FF_AddControl "Exif-Auswahl","Abbrechen","BUTTON",190,85,33,11
FF_AddControl "Exif-Auswahl","bernehmen","BUTTON",237,85,36,11
'** End Dialog Exif-Auswahl **

Array_P = split(ExifDatenliste,";")
for each element in Array_P
	FF_SetControl "Exif-Auswahl","Exif_Lpassiv",element
next

Array_A = split(Exif_Liste,";")
for each element in Array_A
	FF_SetControl "Exif-Auswahl","Exif_Laktiv",element
next

do
	Select Case FF_ShowDialog ("Exif-Auswahl")
	Case ">","Exif_Lpassiv"	'Doppelklick
		Wert = FF_GetControl("Exif-Auswahl","Exif_Lpassiv")
		if instr(Exif_Liste,Wert) = 0 then
			FF_SetControl "Exif-Auswahl","Exif_Laktiv",Wert
			if len(Exif_Liste) = 0 then
				Exif_Liste = Wert
			else
				Exif_Liste = Exif_Liste & ";" & Wert
			end if
		end if
	Case ">>"
		FF_SetControl "Exif-Auswahl","Exif_Laktiv",""
		Exif_Liste = ExifDatenliste
		for each element in Array_P
			FF_SetControl "Exif-Auswahl","Exif_Laktiv",element	
		next
	Case "<","Exif_Laktiv"	'Doppelklick
		if len(Exif_Liste) > 0 then
			Wert = FF_GetControl("Exif-Auswahl","Exif_Laktiv")
			pos1 = instr(Exif_Liste,Wert)
			pos2 = instr(pos1 +1,Exif_Liste,";")

			if pos1 = 1 and pos2 = 0 then
				Exif_Liste = ""
				FF_SetControl "Exif-Auswahl","Exif_Laktiv",""
			else
				if pos2 > 0 then
					Exif_Liste = left(Exif_Liste,pos1 -1) & mid(Exif_Liste,pos2 +1)
				else
					Exif_Liste = left(Exif_Liste,pos1 -2)
				end if

				FF_SetControl "Exif-Auswahl","Exif_Laktiv",""
				Array_A = split(Exif_Liste,";")
				for each element in Array_A
					FF_SetControl "Exif-Auswahl","Exif_Laktiv",element
				next
			end if
		end if
	Case "<<"
		FF_SetControl "Exif-Auswahl","Exif_Laktiv",""
		Exif_Liste = ""
	Case "?"
		msgbox msg,vbInformation,"Hinweis"
	Case "flag_KeyWord"
	Case "bernehmen"
		FF_WriteProfile RegSchluessel,"Exif_Liste",Exif_Liste
		exit do
	Case "CANCEL","Abbrechen"
		Exif_Liste =  FF_GetProfile (RegSchluessel,"Exif_Liste")
		exit do
	Case Else
	End Select
loop

FF_CloseDialog ("Exif-Auswahl")

End Sub
'------------------------------------------------------------------------
Sub IPTC_Auswahl
'IPTC_Lpassiv IPTC_Laktiv
const IPTCDatenliste = "Copyright | CopyrightNotice;Objektbeschreibung | Caption/Abstract;Fotograf | Writer/Editor;berschrift | Headline;Besondere Hinweise | SpecialInstructions;Schlagwrter | Keywords;Kategorie | Category;Weitere Kategorien | SupplementalCategory;Dringlichkeit | Urgency;Autor | Byline;Titel des Autors | BylineTitle;Rechte | Credit;Quelle | Source;Objektname | ObjectName;Erstellungsdatum | DateCreated;Erstellungszeit | TimeCreated;Stadt | City;Zustzlicher Standort | Sublocation;Region | ProvinceState;Land | Country;Lndercode | CountryCode;Auftraggeber-Code | OriginalTransmissionReference;Bearbeitungsstatus | EditStatus;Objektattribut | ObjectAttributeRef;Referenznummer | SubjectRef;Zeichensatz | Characterset"

Dim Array_P,Array_A,element,Wert,pos1,pos2

'** Start Dialog IPTC-Auswahl **
FF_AddDialog "IPTC-Auswahl",283,119
FF_AddControl "IPTC-Auswahl","bei 'Schlagwrter' in der Transferliste","GROUP",44,87,133,24
FF_AddControl "IPTC-Auswahl","Verfgungsliste","STATIC",5,5,50,10
FF_AddControl "IPTC-Auswahl","IPTC_Lpassiv","LISTBOX",5,15,126,66
FF_AddControl "IPTC-Auswahl",">","BUTTON",135,18,12,11
FF_AddControl "IPTC-Auswahl",">>","BUTTON",135,31,12,11
FF_AddControl "IPTC-Auswahl","<<","BUTTON",135,47,12,11
FF_AddControl "IPTC-Auswahl","<","BUTTON",135,62,12,11
FF_AddControl "IPTC-Auswahl","Transferliste","STATIC",151,5,50,10
FF_AddControl "IPTC-Auswahl","IPTC_Laktiv","LISTBOX",151,15,126,66
FF_AddControl "IPTC-Auswahl","?","BUTTON",9,96,11,11
FF_AddControl "IPTC-Auswahl","Abbrechen","BUTTON",195,96,33,11
FF_AddControl "IPTC-Auswahl","bernehmen","BUTTON",237,96,36,11
FF_AddControl "IPTC-Auswahl","zustzliches Schlagwort","STATIC",48,97,60,10
FF_AddControl "IPTC-Auswahl","flag_KeyWord","BOOL",111,98,8,8
FF_SetControlStyle "IPTC-Auswahl","flag_KeyWord",16384
FF_AddControl "IPTC-Auswahl","Z_KeyWord","SLEDIT",127,97,46,10
FF_SetControlStyle "IPTC-Auswahl","Z_KeyWord",1
'** End Dialog IPTC-Auswahl **

Array_P = split(IPTCDatenliste,";")
for each element in Array_P
	FF_SetControl "IPTC-Auswahl","IPTC_Lpassiv",element
next

Array_A = split(IPTC_Liste,";")
for each element in Array_A
	FF_SetControl "IPTC-Auswahl","IPTC_Laktiv",element
next

if instr(IPTC_Liste,"Keywords") = 0 then
	FF_EnableControl "IPTC-Auswahl","flag_KeyWord",false
	FF_EnableControl "IPTC-Auswahl","Z_KeyWord",false
end if
FF_SetControl "IPTC-Auswahl","flag_KeyWord",flag_KeyWord
FF_SetControl "IPTC-Auswahl","Z_KeyWord",Z_KeyWord

do
	Select Case FF_ShowDialog ("IPTC-Auswahl")
	Case ">","IPTC_Lpassiv"	'Doppelklick
		Wert = FF_GetControl("IPTC-Auswahl","IPTC_Lpassiv")
		if instr(Wert,"Keywords") > 0 then
			FF_EnableControl "IPTC-Auswahl","flag_KeyWord",true
			FF_EnableControl "IPTC-Auswahl","Z_KeyWord",true
		end if
		if instr(IPTC_Liste,Wert) = 0 then
			FF_SetControl "IPTC-Auswahl","IPTC_Laktiv",Wert
			if len(IPTC_Liste) = 0 then
				IPTC_Liste = Wert
			else
				IPTC_Liste = IPTC_Liste & ";" & Wert
			end if
		end if
	Case ">>"
		FF_SetControl "IPTC-Auswahl","IPTC_Laktiv",""
		IPTC_Liste = IPTCDatenliste
		for each element in Array_P
			FF_SetControl "IPTC-Auswahl","IPTC_Laktiv",element
		next
		FF_EnableControl "IPTC-Auswahl","flag_KeyWord",true
		FF_EnableControl "IPTC-Auswahl","Z_KeyWord",true
	Case "<","IPTC_Laktiv"	'Doppelklick
		if len(IPTC_Liste) > 0 then
			Wert = FF_GetControl("IPTC-Auswahl","IPTC_Laktiv")
			if instr(Wert,"Keywords") > 0 then
				FF_SetControl "IPTC-Auswahl","flag_KeyWord",0
				FF_EnableControl "IPTC-Auswahl","flag_KeyWord",false
				FF_EnableControl "IPTC-Auswahl","Z_KeyWord",false
			end if
			pos1 = instr(IPTC_Liste,Wert)
			pos2 = instr(pos1 +1,IPTC_Liste,";")

			if pos1 = 1 and pos2 = 0 then
				IPTC_Liste = ""
				FF_SetControl "IPTC-Auswahl","IPTC_Laktiv",""
			else
				if pos2 > 0 then
					IPTC_Liste = left(IPTC_Liste,pos1 -1) & mid(IPTC_Liste,pos2 +1)
				else
					IPTC_Liste = left(IPTC_Liste,pos1 -2)
				end if

				FF_SetControl "IPTC-Auswahl","IPTC_Laktiv",""
				Array_A = split(IPTC_Liste,";")
				for each element in Array_A
					FF_SetControl "IPTC-Auswahl","IPTC_Laktiv",element
				next
			end if
		end if
	Case "<<"
		FF_SetControl "IPTC-Auswahl","IPTC_Laktiv",""
		IPTC_Liste = ""
		FF_SetControl "IPTC-Auswahl","flag_KeyWord",0
		FF_EnableControl "IPTC-Auswahl","flag_KeyWord",false
		FF_EnableControl "IPTC-Auswahl","Z_KeyWord",false
	Case "?"
		msgbox msg,vbInformation,"Hinweis"
	Case "flag_KeyWord"
		if FF_GetControl("IPTC-Auswahl","flag_KeyWord") = 1 then
			msgbox 	"Allen JPG- bzw. TIF-Bildern im gewhlten Ordner mit" & vbNewLine & _
					"gleichem Stammnamen wird das eingetragene,zustzliche" & vbNewline & _
					"Schlagwort zugewiesen!",vbExclamation,"Achtung!"
		end if
	Case "bernehmen"
		flag_KeyWord = FF_GetControl("IPTC-Auswahl","flag_KeyWord")
		Z_KeyWord = trim(FF_GetControl("IPTC-Auswahl","Z_KeyWord"))
		if 	flag_KeyWord = 1 and len(Z_KeyWord) = 0 then
			msgbox 	"Die Option 'zustzliches Schlagwort' ist aktiviert," & vbNewline & _
					"aber es ist kein Schlagwort eingetragen!",vbExclamation,"Hinweis"
		else
			FF_WriteProfile RegSchluessel,"flag_KeyWord",flag_KeyWord
			FF_WriteProfile RegSchluessel,"Z_KeyWord",Z_KeyWord
			FF_WriteProfile RegSchluessel,"IPTC_Liste",IPTC_Liste
			exit do
		end if
	Case "CANCEL","Abbrechen"
		IPTC_Liste =  FF_GetProfile (RegSchluessel,"IPTC_Liste")
		flag_KeyWord =  FF_GetProfile (RegSchluessel,"flag_KeyWord")
		Z_KeyWord =  FF_GetProfile (RegSchluessel,"Z_KeyWord")
		exit do
	Case Else
	End Select
loop

FF_CloseDialog ("IPTC-Auswahl")

End Sub
'------------------------------------------------------------------------
